Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkInitialValueProblemSolver Class Reference

`#include <vtkInitialValueProblemSolver.h>`

Inheritance diagram for vtkInitialValueProblemSolver:

[legend]
Collaboration diagram for vtkInitialValueProblemSolver:

[legend]
List of all members.

## Detailed Description

Integrate a set of ordinary.

Date:
  2002/12/11 22:47:41

Revision:
  1.14

differential equations (initial value problem) in time.

Given a vtkFunctionSet which returns dF_i(x_j, t)/dt given x_j and t, vtkInitialValueProblemSolver computes the value of F_i at t+deltat.

Warning:
  vtkInitialValueProblemSolver and it's subclasses are not thread-safe. You should create a new integrator for each thread.

See also:
  vtkRungeKutta2 vtkRungeKutta4

Created by:
  - Geveci, Berk

CVS contributions (if > 5%):
  - Geveci, Berk (87%)
  - Cedilnik, Andy (9%)

CVS logs (CVSweb):
  - .`cxx` (`/Common/vtkInitialValueProblemSolver.cxx)`
  - .`h` (`/Common/vtkInitialValueProblemSolver.h)`

Definition at line 53 of file vtkInitialValueProblemSolver.h.

## Public Types
typedef vtkObject | Superclass
enum | ErrorCodes { OUT_OF_DOMAIN = 1, NOT_INITIALIZED = 2, UNEXPECTED_VALUE = 3 }
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
virtual void | PrintSelf (ostream &os, vtkIndent indent)
virtual int | IsAdaptive ()
virtual int | ComputeNextStep (float *xprev, float *xnext, float t, float &delT, float maxError, float &error)
virtual int | ComputeNextStep (float *xprev, float *dxprev, float *xnext, float t, float &delT, float maxError, float &error)
virtual int | ComputeNextStep (float *xprev, float *xnext, float t, float &delT, float &delTActual, float minStep, float maxStep, float maxError, float &error)
virtual int | ComputeNextStep (float *xprev, float *dxprev, float *xnext, float t, float &delT, float &delTActual, float minStep, float maxStep, float maxError, float &error)=0
virtual void | SetFunctionSet (vtkFunctionSet *functionset)
virtual vtkFunctionSet * | GetFunctionSet ()
## Static Public Methods
int | IsTypeOf (const char *type)
vtkInitialValueProblemSolver * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkInitialValueProblemSolver ()
| ~vtkInitialValueProblemSolver ()
virtual void | Initialize ()
## Protected Attributes
vtkFunctionSet * | FunctionSet
float * | Vals
float * | Derivs
int | Initialized
int | Adaptive

## Member Typedef Documentation

typedef vtkObject vtkInitialValueProblemSolver::Superclass

| Reimplemented from vtkObject. Reimplemented in vtkRungeKutta2, vtkRungeKutta4, and vtkRungeKutta45. Definition at line 56 of file vtkInitialValueProblemSolver.h.

## Member Enumeration Documentation

enum vtkInitialValueProblemSolver::ErrorCodes

  | Enumeration values:
  OUT_OF_DOMAIN |
  NOT_INITIALIZED |
  UNEXPECTED_VALUE |
Definition at line 118 of file vtkInitialValueProblemSolver.h.

## Constructor & Destructor Documentation

vtkInitialValueProblemSolver::vtkInitialValueProblemSolver | ( |  | ) | `[protected]`

vtkInitialValueProblemSolver::~vtkInitialValueProblemSolver | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkInitialValueProblemSolver::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkObject. Reimplemented in vtkRungeKutta2, vtkRungeKutta4, and vtkRungeKutta45.

int vtkInitialValueProblemSolver::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject. Reimplemented in vtkRungeKutta2, vtkRungeKutta4, and vtkRungeKutta45.

virtual int vtkInitialValueProblemSolver::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject. Reimplemented in vtkRungeKutta2, vtkRungeKutta4, and vtkRungeKutta45.

vtkInitialValueProblemSolver* vtkInitialValueProblemSolver::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkObject. Reimplemented in vtkRungeKutta2, vtkRungeKutta4, and vtkRungeKutta45.

virtual void vtkInitialValueProblemSolver::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkObject. Reimplemented in vtkRungeKutta4.

virtual int vtkInitialValueProblemSolver::ComputeNextStep | ( | float * | xprev,
|  | float * | xnext,
|  | float | t,
|  | float & | delT,
|  | float | maxError,
|  | float & | error
| ) | `[inline, virtual]`

| Given initial values, xprev , initial time, t and a requested time interval, delT calculate values of x at t+delTActual (xnext). For certain concrete sub-classes delTActual != delT. This occurs when the solver supports adaptive stepsize control. If this is the case, the solver tries to change to stepsize such that the (estimated) error of the integration is less than maxError. The solver will not set the stepsize smaller than minStep or larger than maxStep. Also note that delT is an in/out argument. Adaptive solvers will modify delT to reflect the best (estimated) size for the next integration step. An estimated value for the error is returned (by reference) in error. Note that only some concrete sub-classes support this. Otherwise, the error is set to 0. This method returns an error code representing the nature of the failure: OutOfDomain = 1, NotInitialized = 2, UnexpectedValue = 3 Reimplemented in vtkRungeKutta2, vtkRungeKutta4, and vtkRungeKutta45. Definition at line 74 of file vtkInitialValueProblemSolver.h. Referenced by vtkRungeKutta45::ComputeNextStep(), vtkRungeKutta4::ComputeNextStep(), and vtkRungeKutta2::ComputeNextStep().

virtual int vtkInitialValueProblemSolver::ComputeNextStep | ( | float * | xprev,
|  | float * | dxprev,
|  | float * | xnext,
|  | float | t,
|  | float & | delT,
|  | float | maxError,
|  | float & | error
| ) | `[inline, virtual]`

| Given initial values, xprev , initial time, t and a requested time interval, delT calculate values of x at t+delTActual (xnext). For certain concrete sub-classes delTActual != delT. This occurs when the solver supports adaptive stepsize control. If this is the case, the solver tries to change to stepsize such that the (estimated) error of the integration is less than maxError. The solver will not set the stepsize smaller than minStep or larger than maxStep. Also note that delT is an in/out argument. Adaptive solvers will modify delT to reflect the best (estimated) size for the next integration step. An estimated value for the error is returned (by reference) in error. Note that only some concrete sub-classes support this. Otherwise, the error is set to 0. This method returns an error code representing the nature of the failure: OutOfDomain = 1, NotInitialized = 2, UnexpectedValue = 3 Reimplemented in vtkRungeKutta2, vtkRungeKutta4, and vtkRungeKutta45. Definition at line 84 of file vtkInitialValueProblemSolver.h.

virtual int vtkInitialValueProblemSolver::ComputeNextStep | ( | float * | xprev,
|  | float * | xnext,
|  | float | t,
|  | float & | delT,
|  | float & | delTActual,
|  | float | minStep,
|  | float | maxStep,
|  | float | maxError,
|  | float & | error
| ) | `[inline, virtual]`

| Given initial values, xprev , initial time, t and a requested time interval, delT calculate values of x at t+delTActual (xnext). For certain concrete sub-classes delTActual != delT. This occurs when the solver supports adaptive stepsize control. If this is the case, the solver tries to change to stepsize such that the (estimated) error of the integration is less than maxError. The solver will not set the stepsize smaller than minStep or larger than maxStep. Also note that delT is an in/out argument. Adaptive solvers will modify delT to reflect the best (estimated) size for the next integration step. An estimated value for the error is returned (by reference) in error. Note that only some concrete sub-classes support this. Otherwise, the error is set to 0. This method returns an error code representing the nature of the failure: OutOfDomain = 1, NotInitialized = 2, UnexpectedValue = 3 Reimplemented in vtkRungeKutta2, vtkRungeKutta4, and vtkRungeKutta45. Definition at line 94 of file vtkInitialValueProblemSolver.h.

virtual int vtkInitialValueProblemSolver::ComputeNextStep | ( | float * | xprev,
|  | float * | dxprev,
|  | float * | xnext,
|  | float | t,
|  | float & | delT,
|  | float & | delTActual,
|  | float | minStep,
|  | float | maxStep,
|  | float | maxError,
|  | float & | error
| ) | `[pure virtual]`

| Given initial values, xprev , initial time, t and a requested time interval, delT calculate values of x at t+delTActual (xnext). For certain concrete sub-classes delTActual != delT. This occurs when the solver supports adaptive stepsize control. If this is the case, the solver tries to change to stepsize such that the (estimated) error of the integration is less than maxError. The solver will not set the stepsize smaller than minStep or larger than maxStep. Also note that delT is an in/out argument. Adaptive solvers will modify delT to reflect the best (estimated) size for the next integration step. An estimated value for the error is returned (by reference) in error. Note that only some concrete sub-classes support this. Otherwise, the error is set to 0. This method returns an error code representing the nature of the failure: OutOfDomain = 1, NotInitialized = 2, UnexpectedValue = 3 Implemented in vtkRungeKutta2, vtkRungeKutta4, and vtkRungeKutta45.

virtual void vtkInitialValueProblemSolver::SetFunctionSet | ( | vtkFunctionSet * | functionset | ) | `[virtual]`

| Set / get the dataset used for the implicit function evaluation.

virtual vtkFunctionSet* vtkInitialValueProblemSolver::GetFunctionSet | ( |  | ) | `[virtual]`

| Set / get the dataset used for the implicit function evaluation.

virtual int vtkInitialValueProblemSolver::IsAdaptive | ( |  | ) | `[inline, virtual]`

| Returns 1 if the solver uses adaptive stepsize control, 0 otherwise Definition at line 115 of file vtkInitialValueProblemSolver.h.

virtual void vtkInitialValueProblemSolver::Initialize | ( |  | ) | `[protected, virtual]`

| Reimplemented in vtkRungeKutta4, and vtkRungeKutta45.

## Member Data Documentation

vtkFunctionSet* vtkInitialValueProblemSolver::FunctionSet`[protected]`

| Definition at line 132 of file vtkInitialValueProblemSolver.h.

float* vtkInitialValueProblemSolver::Vals`[protected]`

| Definition at line 134 of file vtkInitialValueProblemSolver.h.

float* vtkInitialValueProblemSolver::Derivs`[protected]`

| Definition at line 135 of file vtkInitialValueProblemSolver.h.

int vtkInitialValueProblemSolver::Initialized`[protected]`

| Definition at line 136 of file vtkInitialValueProblemSolver.h.

int vtkInitialValueProblemSolver::Adaptive`[protected]`

| Definition at line 137 of file vtkInitialValueProblemSolver.h.

The documentation for this class was generated from the following file:

- Common/vtkInitialValueProblemSolver.h